## GUISearch:  Browse/Search Code of Applications written using a GUI Framework
## Copyright (C) 2001 Amir Michail

## This program is free software; you can redistribute it and/or
## modify it under the terms of the GNU General Public License
## as published by the Free Software Foundation; either version 2
## of the License, or (at your option) any later version. 

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

import string
import anydbm

## extract body of function starting at this line
##   just do a simple {, } count
##   it will work most of the time
##   might also stop if we have } in col 0
## can get confused by {} in strings, comments, etc.

def extract_body( appdir, fn, lineno ):
  body = ""
  f = open( appdir+fn, "r" )
  l = 0

  found_first = 0
  brace_count = 0

  while 1:
    line = f.readline()
    l = l + 1
    if line == "":
      break

    if l >= lineno:

      body = body + line
      for ch in line:
        if ch == "{":
          found_first = 1
          brace_count = brace_count +1
        elif ch == "}":
          brace_count = brace_count -1

      if found_first and brace_count == 0:
        #print "brace count down to 0"
        break
      
      if line.find("}") == 0:
        #print "found } in col 0"
        break

    

  f.close()
  #print "end************************************"
  return body



## returns list of functions found in code
def extract_functions(app,body):
  ret = []
  l = body.split("(")
  l = l[0:len(l)-1] # skip last element
  for unstripped in l:
    w = string.strip(unstripped)
    w2 = w
    r = range(0, len(w))
    r.reverse()
    for i in r:
      if w[i] != '_' and not (w[i] in string.letters):
        if not (i>0 and w[i] in string.digits):
          w2 = w[i+1:]
          break
#    print "####" + w + " => " + w2
    f = app+"'"+w2 + "()"
    if not f in ret:
      ret.append(f)
  return ret

def hypertext(app,body,exclude_function):
  d = anydbm.open("function_source.db","r")
  result = ""
  l = body.split("(")
  for w in l:  # there could be a space just before (
    w2 = w
    r = range(0, len(w))
    r.reverse()
    started = 0
    for i in r:
      if w[i] == ' ' and not started:
        continue # skip space before (
      started = 1
      if w[i] != '_' and not (w[i] in string.letters):
        if not (i>0 and w[i] in string.digits):
          w2 = w[i+1:]
          break
#    print "####-" + w + "- => *" + w2 +"*"
    inbetween = w[0:len(w)-len(w2)]
    result = result + inbetween
    if w2 != "":
      f = app+"'"+w2+"()"
      ## check to see if defined in app
      if f == exclude_function:
        result = result + "<B>"+w2 + "</B>("
      elif d.has_key(f):
        result = result + "<A HREF=\"guisearch.cgi?query=fsrc:" +f + "\">" + w2 + "</A>("
      else:
        result = result + w2 + "("
  d.close()
  return result
