## GUISearch:  Browse/Search Code of Applications written using a GUI Framework
## Copyright (C) 2001 Amir Michail

## This program is free software; you can redistribute it and/or
## modify it under the terms of the GNU General Public License
## as published by the Free Software Foundation; either version 2
## of the License, or (at your option) any later version. 

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


## notes on circular imports
### http://groups.yahoo.com/group/python-list/message/4347

import os
import sys
import re
import walk
import string
import tempfile
import stemmer
import cpp
import misc
import kde_stdactions
import kde_xml
import kde_tags
import kde_callbacks









#####################################################################


stdaction_english_message = {}
stdaction_english_heading = {}

def processKDEApplication( appdir, kdelibsdir, all_functions, function_parents, is_callback,ms_mem, callback_message,slot_file,slot_lineno ):


    global stdaction_english_message
    global stdaction_english_heading

    #print "...running ctags"
    tags_file = tempfile.mktemp(".guisearch")  #"/home/cvssearch/public_html/horn-html/guisearch/tags"

    ## should probably run ctags in this script
    current_dir = os.getcwd()
    os.chdir(appdir)
    #print "switched directory to " + appdir
    os.system("rm -f " + tags_file)
    s = "ctags -R -I Q_OBJECT -I K_DCOP --file-scope=no --fields=nKs --c-types=f  --c++-types=f -f " + tags_file + " ."
    print s
    os.system(s)
    os.chdir(current_dir)
    #print "switched to dir = " + os.getcwd()


    kde_tags.load_tags(appdir, tags_file, all_functions, function_parents, is_callback,slot_file,slot_lineno)
    os.system("rm -f " + tags_file)

    ## take out children with no body (e.g., if(), etc.)
    ## (obviously, the parents have bodies)

    for child in function_parents.keys():
      if not slot_file.has_key(child):
#        print "removing child with no body: " + child
        assert (not is_callback.has_key(child)) or is_callback[child] == 0
        del function_parents[child]
        assert not function_parents.has_key(child)
        del all_functions[child]
        assert not all_functions.has_key(child)





    if len( stdaction_english_message.keys() ) == 0:
        print "*** loading standard actions"
        kde_stdactions.load_std_actions(kdelibsdir+"kdeui/kstdaction.cpp", kdelibsdir+"kdeui/ui_standards.rc",stdaction_english_message,stdaction_english_heading)

    #print "... loading game standard actions"
    #load_std_actions(root+"kdegames/libkdegames/kstdgameaction.cpp")


    print "*** parsing application source"
    callbacks_obj = kde_callbacks.callbacks( appdir, callback_message, is_callback,stdaction_english_message,stdaction_english_heading,ms_mem )
    for pattern in ["*.cc", "*.cpp", "*.C", "*.CC"]:
        for path in walk.GlobDirectoryWalker(appdir, pattern):
            callbacks_obj.parse(path)




