## GUISearch:  Browse/Search Code of Applications written using a GUI Framework
## Copyright (C) 2001 Amir Michail

## This program is free software; you can redistribute it and/or
## modify it under the terms of the GNU General Public License
## as published by the Free Software Foundation; either version 2
## of the License, or (at your option) any later version. 

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.



import re
import kde_xml


def load_std_actions(fn, rcfn,stdaction_english_message,stdaction_english_heading):

  internal_name_heading = {}
#  print "**** loading std headings"
  kde_xml.load_xml(rcfn, internal_name_heading)


  f = open( fn, "r" )
  original_text=f.read()
  f.close()

  find_action_pattern = re.compile(r"KStd[^;]*?::[^;]*?\(\s*const.*?\bnew\s+K([a-zA-Z0-9_]*?)Action\b.*?stdName.*?;", re.MULTILINE|re.DOTALL)

  find_query_pattern = re.compile(r"\bi18n\s*\(\s*\"([^\"]*?)\"", re.MULTILINE|re.DOTALL)

  find_action_type = re.compile(r"(^[^\s^(^;]*?)\s*\(", re.MULTILINE|re.DOTALL)

  find_stdname_pattern = re.compile(r"stdName\s*\(\s*(.*?)\s*\)", re.MULTILINE|re.DOTALL)


  stdname_method = {}


  text = original_text

  ################ handle custom actions
  while text != "":

    m = find_action_pattern.search(text)
    if ( m == None ):
      break

    action = m.group()
    text = text[m.end():] 

    # pick up string & slot
    m = find_query_pattern.search(action)
    if ( m == None):
#      print "WARNING:  couldn't find query; skipping"
      continue
    query = m.group(1)

    m = find_action_type.search(action)
    if ( m == None):
#      print "WARNING:  couldn't find action type; skipping"
      continue
    type = m.group(1)


    m = find_stdname_pattern.search(action)
    if ( m == None):
#      print "WARNING:  couldn't find stdname; skipping"
      continue
    stdname = m.group(1)


    ## Example:  &File => file_new

#    print "Standard Action:  " + query + " of type -" + type + "-" + " with standard name -" + stdname + "-"
    stdaction_english_message[type] = query
    stdname_method[stdname] = type


  ### left to do:  we need to make the connection between
  ### the stdname (e.g., New) and internal name (e.g., file_new)

  find_pairing_pattern = re.compile(r"\bcase\s*([^;]*?):[^;]*?\"([^;]*?)\"\s*;", re.MULTILINE|re.DOTALL)

  text = original_text

  while text != "":

    m = find_pairing_pattern.search(text)
    if ( m == None ):
      break

    pairing = m.group()
    stdname = m.group(1)
    internalname = m.group(2)
    assert stdname_method.has_key(stdname)

    # check required since xml file missing some internal names
    if internal_name_heading.has_key(internalname):
      stdaction_english_heading[ stdname_method[stdname] ] = internal_name_heading[internalname]
      stdaction_english_heading[ stdname_method[stdname] ] = internal_name_heading[internalname]
#      print "**** " +  stdname_method[stdname] + " => " +  internal_name_heading[internalname]

    text = text[m.end():] 


