## GUISearch:  Browse/Search Code of Applications written using a GUI Framework
## Copyright (C) 2001 Amir Michail

## This program is free software; you can redistribute it and/or
## modify it under the terms of the GNU General Public License
## as published by the Free Software Foundation; either version 2
## of the License, or (at your option) any later version. 

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.



import re
import misc
import cpp

def load_tags( appdir, tags_fn, all_functions, function_parents, is_callback,slot_file, slot_lineno ):
  print "*** loading tags in " + tags_fn

  find_event_pattern = re.compile(r"::\s*[0-9a-zA-Z_]+Event\s*\(\s*[QK][0-9a-zA-Z_]*Event")
  
  f = open(tags_fn, "r")
  while 1:
    line = f.readline()
    if line == "":
      break
    if line[0] == "!":
      continue
    fields = line.split("\t")
    if fields[3] != "function":
      continue


    function = fields[0] + "()"
    file = fields[1]

#    package = misc.extract_package( appdir, file )
#    app = misc.extract_app( file )

    lineno = fields[4]
    assert lineno.find(":") != -1
    lineno = int(lineno[ lineno.find(":")+1:])

    scope = ""

    try:
      scope = fields[5] # may not be defined in a class
      assert scope.find(":") != -1
      scope = scope[ scope.find(":") + 1:] # might be in class, struct, etc.
    except IndexError:
      scope = "[global]"

    if scope.find("\n") != -1:
      scope = scope[0:scope.find("\n")]

#    assert package != ""
#    assert app != ""
    k = appdir + "'" + function 
#    if slot_file.has_key(k):
#      print "*** WARNING:  already encountered " + k
    if not slot_file.has_key(k):
      slot_file[k] = []
      assert not slot_lineno.has_key(k)
      slot_lineno[k] = []
    slot_file[k].append( file )
    slot_lineno[k].append( lineno )

    all_functions[k] = 1

    ### experimental
    body = cpp.extract_body( appdir, file, lineno )

    parent = appdir + "'" + function

    ### check if this is an event handler
    m = find_event_pattern.search(body)
    if m == None:
      is_callback[parent] = 0

    else:
      is_callback[parent] = 1 #function_depth[parent] = 0
#      print "************** found event handler " + parent
    
    children = cpp.extract_functions(appdir,body)

    for child in children:
      if child != parent:
        all_functions[child] = 1
        is_callback[child] = 0
        if not function_parents.has_key(child):
          function_parents[child] = []
        if not (parent in function_parents[child]):
          function_parents[child].append(parent)
    

##
## output format looks like this:
##
## identifier \t file \t search pattern \t function \t line:?? \t class:??
    
  f.close()
  
