## GUISearch:  Browse/Search Code of Applications written using a GUI Framework
## Copyright (C) 2001 Amir Michail

## This program is free software; you can redistribute it and/or
## modify it under the terms of the GNU General Public License
## as published by the Free Software Foundation; either version 2
## of the License, or (at your option) any later version. 

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.



import os
import kde_xml_parser
from xml.sax import make_parser
from xml.sax.handler import feature_namespaces
from xml.sax import saxutils
from xml.sax import handler
import xml.sax
import walk

def load_xml(rcfn, internal_name_heading):

  internal_name_heading.clear()

  filename_list = []

  if rcfn.find(".rc") != -1:
    filename_list.append(rcfn)
  else:
    if os.access( rcfn, os.F_OK ): # given directory here if no .rc extension
      ## note that this is a recursive walk!
      ## may or may not be want we want
      filename_list = walk.GlobDirectoryWalker(rcfn, "*.rc")


  for fn in filename_list:
#    print "*** loading xml file -" + fn + "-"
    f = open( fn, "r" )

    # Create an instance of the handler classes
    ph = kde_xml_parser.parse_rc(internal_name_heading)
    
    # Create an XML parser
    parser = kde_xml_parser.make_parser()

    # Tell the parser we are not interested in XML namespaces
    parser.setFeature(feature_namespaces, 0)

    # Tell the parser to use your handler instance
    parser.setContentHandler(ph)

    try:
        parser.parse(f)
#        print "NO PARSE ERRORS"
    except xml.sax._exceptions.SAXParseException:
        print "XML parse errors in " + fn

    f.close()

##      print "*** xml action -" + heading + "- => -" + name + "-"
##      internal_name_heading[name] = heading
