## GUISearch:  Browse/Search Code of Applications written using a GUI Framework
## Copyright (C) 2001 Amir Michail

## This program is free software; you can redistribute it and/or
## modify it under the terms of the GNU General Public License
## as published by the Free Software Foundation; either version 2
## of the License, or (at your option) any later version. 

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.





## NOTE:  XML is case sensitive!

## URL:  http://py-howto.sourceforge.net/xml-howto/SAX.html

## warning: need to download expat library to get this to work
## new version doesn't work with python; need old version here:
## http://www.jclark.com/xml/expat.html

## see:  http://groups.google.com/groups?hl=en&safe=off&th=919be7dc22bec43b,4&seekm=3B13FC0E.81FAC10B%40raqia.com#p

import walk

from xml.sax import make_parser
from xml.sax.handler import feature_namespaces
from xml.sax import saxutils
from xml.sax import handler
import xml.sax
import sys
import string

## ContentHandler
##
## Called for general document events.
##
## (there are also other types of handlers)

def normalize_whitespace(text):
    "Remove redundant whitespace from a string"
    return string.join(string.split(text), ' ')



class parse_rc(handler.ContentHandler):

    def __init__(self, internal_name_heading):
        self.inHeading = 0
        self.inMenu = 0
        self.heading_start_ok = 0
        
        self.heading = ""
        self.menu = ""
        self.internal_name_heading = internal_name_heading


    ##
    ## bug:  don't pick up macros like &kmail;
    ##
    ## a bit of a hack so that in most cases,
    ## we only have menu defined after menu item
    ## if there is no text between the two
    def characters(self, ch):
        if self.inHeading:
            self.heading = self.heading + ch
            self.menu = ""
        elif self.inMenu:
            self.menu = self.menu + ch
        else:
            self.menu = ""
        
    def startElement(self, name, attrs):
        if name == "text":
            if self.heading_start_ok:
                self.heading = ""
                self.inHeading = 1
                self.heading_start_ok = 0
            else:
                self.heading = ""
                self.inHeading = 0
        elif name == "Menu":            
            self.heading_start_ok = 1
        elif name == "Action":
            internal_name = normalize_whitespace(attrs.get("name", None))
            if self.heading != "":
                self.internal_name_heading[ internal_name ] = self.heading

        
    def endElement(self, name):

        self.heading_start_ok = 0
        
        if name == "text":
            if self.inHeading:
                self.heading = normalize_whitespace(self.heading)
            self.inHeading = 0
        elif name == "Menu":
            self.heading = ""
             


