#! /usr/bin/env python

## GUISearch:  Browse/Search Code of Applications written using a GUI Framework
## Copyright (C) 2001 Amir Michail

## This program is free software; you can redistribute it and/or
## modify it under the terms of the GNU General Public License
## as published by the Free Software Foundation; either version 2
## of the License, or (at your option) any later version. 

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.



import string
import anydbm
import re
import sys

import stemmer

class Search:
    def __init__(self, wordslots_fn):
        self.wordslots = anydbm.open(wordslots_fn, "r")
        self.porter = stemmer.PorterStemmer()
        
    def search(self, word_list): # query is a list of words
        final_list = []
        first = 1
        for word in word_list:
    ## sometimes we get empty string, no idea why
            if word != "":
                lc = string.lower(word)
                if not lc.find("in:") == 0:  ## do not stem in: commands
                    lc = self.porter.stem(lc)        

                if self.wordslots.has_key(lc):
                    answer_list = string.split( self.wordslots[lc], "\000" ) # may have > 1 slots
                    if first == 1:
                        final_list = answer_list
                    else:
                        new_final_list = []
                        for answer in answer_list:
                            if answer != "":
                                if answer in final_list:
                                    new_final_list.append(answer)
                        final_list = new_final_list
                else:
                    final_list = []
                first = 0
        return final_list

    
